const BASE_URL = 'https://olarmsapi.ogunstate.gov.ng/api/v1/';
const WS_URL = 'https://martforte.pusher.com:8555/auth';

function authHeader(){return{"Content-Type":"application/json",Accept:"application/json",Authorization:"Bearer "+localStorage.getItem("token")}}async function logout(){await localStorage.setItem("redirect_url",window.location.href),await localStorage.removeItem("token"),window.location.href=await"/account/login"}

//function handleResponse(e){return e.text().then(async t=>{if(!e.ok)return 401===e.status?e.url.includes("auth")||logout():403===e.status?e.url===`${BASE_URL}account/profile`||logout():e.status,Promise.reject(JSON.parse(t));r.token&&r.refreshUser&&(localStorage.setItem("user",JSON.stringify(r.refreshUser)),await localStorage.setItem("token",r.token),await evalMenu());const r=t&&JSON.parse(t);return r})}

async function login(t,e){await localStorage.setItem("user",e),await localStorage.setItem("token",t);const o=localStorage.getItem("redirect_url");window.location.href=await o?o:"/"}

function formatCurrency(t,r){if("null"!=t&&"0"!=t){let e;return(e=Number.isInteger(t)?t.toFixed(2).toString().split("."):Number(t).toFixed(2).toString().split("."))[0]=e[0].replace(/\B(?=(\d{3})+(?!\d))/g,","),(r?"₦":"")+e.join(".")}return(r?"₦":"")+"0"}

function optArr(e,o,n,t,r){document.querySelectorAll("#"+e+" option").forEach(e=>e.remove()),byId(e).innerHTML=r?"<option selected disabled value>"+(!0!==r?r:"")+"</option>":"",o.forEach(o=>{const r=document.createElement("option");r.value=n?o[n]:o,r.innerHTML=t?o[t]:o,byId(e).add(r)})}

function queryUrl(e){return e?JSON.parse('{"'+e.substring(1).replace(/"/g,'\\"').replace(/&/g,'","').replace(/=/g,'":"')+'"}'):{}}

let lgas = ['Abeokuta North', 'Abeokuta South', 'Ado-Odo/Ota', 'Ewekoro', 'Ifo', 'Ijebu East', 'Ijebu North', 'Ijebu North East', 'Ijebu Ode', 'Ikenne', 'Imeko Afon', 'Ipokia', 'Obafemi Owode', 'Odogbolu', 'Odeda', 'Ogun Waterside', 'Remo North', 'Sagamu (Shagamu)', 'Yewa North (formerly Egbado North)', 'Yewa South (formerly Egbado South)']
let officer_building_types = [{id:1, name:'Bungalow'},{id:2,name:'Two Floors'},{id:3,name:'Above Two Floors'}] 

function evalMenu(){
    const user = JSON.parse(localStorage.getItem('user'));
    if(user.menu && !location.pathname.includes('doc_uploads')) {
        user.menu.forEach(m => {
            const menu = document.querySelector('#'+m);
            if(menu) menu.style.display = null;
            if(!menu) menu.style.display = 'none';
        });
        
        const hr = document.querySelector('#hr-schemes');
        const hrs = document.querySelector('#hr-settings');
        
        if(user.menu.includes('schemes')){
            if(hr) hr.style.display = null;
        } else {
            if(hr) hr.style.display = 'none';
        }
        
        const hrSettings = ["users","roles","emails","settings"];

        const existsIn = [hrSettings,user.menu].reduce((a, b) => a.filter(c => b.includes(c)));
        if(existsIn.length>0){
            if(hrs) hrs.style.display = null;
        } else {
            if(hrs) hrs.style.display = 'none';

        }
    }
}

function parseJwt (token) {
    var base64Url = token.split('.')[1];
    var base64 = base64Url.replace(/-/g, '+').replace(/_/g, '/');
    var jsonPayload = decodeURIComponent(atob(base64).split('').map(function(c) {
        return '%' + ('00' + c.charCodeAt(0).toString(16)).slice(-2);
    }).join(''));

    return JSON.parse(jsonPayload);
};

async function fetchAuth(runFn, runArgs, retryFn){
    const token = localStorage.getItem('token');

    if(token){
        if(parseJwt(token)){
            const tk = parseJwt(token);

            if((tk.exp-900)*1000>Date.now()){
                runFn(runArgs);
            } else if((tk.exp+1209500)*1000>Date.now()) {
                const requestOptions = {
                    method: 'GET',
                    headers: authHeader()
                };
                let res = await fetch(BASE_URL+'auth/user_refresh', requestOptions).then(handleResponse).catch(e => { showNetworkError(retryFn);if(e&&e.message=='Server Error') logout();});
                if(res) {await localStorage.setItem('token',res.token);
                let req = await fetch(BASE_URL+'admin/get_user', {method: 'GET', headers: {...authHeader(), Authorization: "Bearer "+res.token}}).then(handleResponse);
                await runFn(runArgs);}
            } else {console.log('3');
                logout();
            }
        } else {
            logout();
        }
    } else {
        logout();
    }
}

function handleResponse(response){
    return response.text().then(async text => {
        if (!response.ok) {
            if (response.status === 401) {
                if(response.url.includes('auth/user')){
                } else {
                    logout();
                }
            } else if (response.status === 403) {
                if(response.url.includes('auth/user')){
                } else {
                    //fetchAuth(window.location.href = '/',null,null);
                }
            } else if (response.status === 418) {
            }
            return Promise.reject(JSON.parse(text));
        } else {
            const data = text && JSON.parse(text);
            if(data.token && data.refreshUser){
                localStorage.setItem("user",JSON.stringify(data.refreshUser)),await localStorage.setItem("token",data.token);
                await evalMenu();
            }

            return data;
        }
  }).catch(e => {return Promise.reject(e);});
}

function runIt(){}

async function fetchX(url, options){
  const auth = await fetchAuth(runIt);
  const response = await fetch(url, {...options, headers: authHeader()});
  return await response;
}

function showNetworkError(){
    document.querySelector('.logo-spin').style.animation = 'rotation 15s infinite linear';
    document.getElementById('page-loader-retry').style.display = null;
    document.getElementById('page-loader-text').style.display = 'none';
}

var addFunctionOnWindowLoad = function(callback){
    if(window.addEventListener){
        window.addEventListener('load',callback,false);
    } else {
        window.attachEvent('onload',callback);
    }
}

if(location.pathname.includes('profile') || !location.pathname.includes('account')) addFunctionOnWindowLoad(evalMenu);
